/*
  gcc -Wall `pkg-config fuse --cflags --libs` -o melangefs melangefs.c
*/

#include "melangefs.h"         // need it here because of FUSE_USE_VERSION

#include <ctype.h>
#include <dirent.h>
#include <errno.h>
#include <fcntl.h>
#include <fuse.h>
#include <libgen.h>
#include <limits.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/xattr.h>

/*
 * This is just an helper function to help you debug. 
 * You may choose to delete it and use your own function.
 */
static 
int melange_error(char *error_str)
{
    int retval = -errno;

    // TODO:
    //
    // You may want to add your own logging/debugging functions for printing
    // error messages. For example:
    //
    // debug_msg("ERROR happened. %s\n", error_str, strerror(errno));
    //

    /* FUSE always returns -errno to caller (yes, it is negative errno!) */
    return retval;
}

/*
 * Another function for the usability of your program.
 */
static 
void usage()
{
    fprintf(stderr, 
            "USAGE:  melangefs <threshold> <SSDmount> <HDDmount> <FUSEmount>\n");
    abort();
}

/*
 * Initializes the FUSE file system (melangefs) by checking if the mount points
 * are valid, and if all is well, it mounts the file system ready for usage.
 *
 * XXX: You are NOT ALLOWED to add anything in this function because you can do
 *      a lot of tricks at mount point, and we don't want you to do that :-)
 */
void *melange_init(struct fuse_conn_info *conn)
{
    return MELANGE_DATA;
}

int melange_getattr(const char *path, struct stat *statbuf)
{
    int retval = 0;

    // 
    // TODO:
    //
    // Implement this function to do whatever it is supposed to do!
    //

    return retval;
}

/*
 * Functions supported by melangefs 
 */
static 
struct fuse_operations melange_operations = {
    .init           = melange_init,
    //
    // TODO
    //
    // This is where you add the VFS functions that your implementation of
    // MelangsFS will support, i.e. replace 'NULL' with 'melange_operation'
    // --- melange_getattr() and melange_init() show you what to do ...
    //
    // Different operations take different types of parameters. This list can
    // be found at the following URL:
    // --- http://fuse.sourceforge.net/doxygen/structfuse__operations.html
    //
    //
    .getattr        = NULL,
    .mkdir          = NULL,
    .readdir        = NULL,
};


int main(int argc, char *argv[])
{
    int fuse_stat;
    struct melange_state *melange_data;
    melange_data = calloc(sizeof(struct melange_state), 1);
    if (melange_data == NULL) {
        fprintf(stdout, "Error during calloc(). %s", strerror(errno));
        return -1;
    }

    // TODO
    //
    // Parse the arguments to set the fields in "struct melange_state" and
    // finding the FUSE mount point.
    // -- NOTE: FUSE always assumes that argv[1] is the mount point, so you
    //          need to play with the passed parameters to ensure that.
    // -- You can also explore the FUSE argument parsing functions documented
    //    at the http://fuse.sourceforge.net/doxygen/fuse__opt_8h.html
    //

    fuse_stat = fuse_main(argc, argv, &melange_operations, melange_data);
    
    return fuse_stat;
}

